﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinDock;

namespace WindowsFormsControlLibrary1
{
   public partial class UserControl1 : UserControl
   {
      public UserControl1()
      {
         InitializeComponent();
      }
   }

   public class MyDockManager : UltraDockManager
   {
      private const int GWL_HWNDPARENT = -8;

      [DllImport("user32.dll", CharSet = CharSet.Auto, ExactSpelling = true)]
      private static extern IntPtr GetParent(IntPtr hWnd);

      [DllImport("user32.dll", EntryPoint = "SetWindowLong", CharSet = CharSet.Auto)]
      private static extern IntPtr SetWindowLongPtr32(IntPtr hWnd, int nIndex, IntPtr dwNewLong);

      [DllImport("user32.dll", EntryPoint = "SetWindowLongPtr", CharSet = CharSet.Auto)]
      private static extern IntPtr SetWindowLongPtr64(IntPtr hWnd, int nIndex, IntPtr dwNewLong);

      public MyDockManager(IContainer container)
         : base(container)
      {
      }

      private static IntPtr SetWindowLong(IntPtr hWnd, int nIndex, IntPtr dwNewLong)
      {
         if (IntPtr.Size == 4)
            return SetWindowLongPtr32(hWnd, nIndex, dwNewLong);

         return SetWindowLongPtr64(hWnd, nIndex, dwNewLong);
      }

      protected override void InitializeFloatingWindowContainer(FloatingWindowContainer floatingWindowContainer)
      {
         if (floatingWindowContainer.Owner != null)
            return;

         if (HostControl == null)
            return;

         IntPtr topLevelWindow = HostControl.Handle;
         IntPtr parentWindow = GetParent(topLevelWindow);

         while (parentWindow != IntPtr.Zero)
         {
            topLevelWindow = parentWindow;
            parentWindow = GetParent(topLevelWindow);
         }

         SetWindowLong(floatingWindowContainer.Handle,GWL_HWNDPARENT,topLevelWindow);
      }
   }
}
